import numpy as np


def sort_with_index(arr):
    sorted_indexes = np.argsort(arr)
    sorted_arr = arr[sorted_indexes]
    return sorted_arr, sorted_indexes


def blkdiag(*arrs):
    shapes = np.array([np.array(arr.shape) for arr in arrs])
    out_shape = np.sum(shapes, axis=0)
    out = np.zeros(out_shape)
    row, col = 0, 0
    for arr in arrs:
        r, c = arr.shape
        out[row:row+r, col:col+c] = arr
        row += r
        col += c

    return out


def levy(xxx):
    # d = len(xxx)
    d = xxx.size
    xxx = xxx.reshape(1, d)
    w = np.zeros((1, d))
    for ii in np.arange(d):
        w[0, ii] = 1 + (xxx[0, ii] - 1) / 4

    term1 = np.sin(np.pi * w[0, 0]) ** 2
    term3 = ((w[0, d-1] - 1) ** 2) * (1 + (np.sin(2 * np.pi * w[0, d-1]) ** 2))
    total_sum = 0
    for ii in np.arange(d-1):
        wi = w[0, ii]
        new = ((wi - 1) ** 2) * (1 + 10*((np.sin(np.pi * wi + 1))**2))
        total_sum = total_sum + new

    yyy = term1 + total_sum + term3
    return yyy


def ackley(xxx):
    d = xxx.size
    xxx = xxx.reshape(1, d)
    c = 2 * np.pi
    b = 0.2
    a = 20

    sum1 = 0
    sum2 = 0
    for ii in np.arange(d):
        xxxi = xxx[0, ii]
        sum1 = sum1 + xxxi ** 2
        sum2 = sum2 + np.cos(c * xxxi)

    term1 = -a * np.exp(-b * np.sqrt(sum1 / d))
    term2 = -np.exp(sum2 / d)
    yyy = term1 + term2 + a + np.exp(1)
    return yyy


def griewank(xxx):
    d = xxx.size
    xxx = xxx.reshape(1, d)
    total_sum = 0
    prod = 1
    for ii in np.arange(d):
        xi = xxx[0, ii]
        total_sum = total_sum + (xi**2)/4000
        prod = prod * np.cos(xi/np.sqrt(ii+1))

    y = total_sum - prod + 1
    return y
